import java.io.*;
import java.text.*;
import java.util.*;

public class DstTest {
    private static final long jan1 = (((2007L-1970) * 365 + 9) * 24 + 8) * 60 * 60 * 1000;
    private static final long mar11 = jan1 + (31L + 28 + 10) * 24 * 60 * 60 * 1000;
    private static final long apr8 = jan1 + ((31L + 28 + 31 + 7) * 24 - 1) * 60 * 60 * 1000;
    private static final long time0030 = 30 * 60 * 1000;
    private static final long time0230 = 150 * 60 * 1000;

    public static boolean doTest(String testName, TimeZone tz, Locale locale) throws Exception {
        System.err.println("========== " + testName + " Test");
        TimeZone.setDefault(tz);
//        System.out.println("Updated default timezone: " + TimeZone.getDefault().getDisplayName(locale));
        Locale.setDefault(locale);
//        System.out.println("New default locale: " + Locale.getDefault());
        // SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss zz", locale);
        // SimpleDateFormat testFormat = new SimpleDateFormat("zz", locale);
        SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss zz");
        SimpleDateFormat testFormat = new SimpleDateFormat("zz");
//        System.out.println("January 1 times - 0.5 hours in and 2.5 hours in [correct = both PST]:");
        Date date = new Date(jan1 + time0030);
        String tzName1 = testFormat.format(date);
 //       System.out.println(format.format(date));
        date = new Date(jan1 + time0230);
        String tzName2 = testFormat.format(date);
//        System.out.println(format.format(date));
        boolean pass = ((tzName1.equals("PST") && tzName2.equals("PST")) ||
			(tzName1.equals("EST") && tzName2.equals("EST")));

        if (pass) {
//            System.out.println("Pass");
        } else {
            System.out.println("FAIL");
            System.out.println("*** Something is very wrong - exiting.");
            System.exit(2);
        }
 //       System.out.println("March 11 times - 0.5 hours in and 2.5 hours in [correct = first PST, second PDT]:");
        date = new Date(mar11 + time0030);
        tzName1 = testFormat.format(date);
  //      System.out.println(format.format(date));
        date = new Date(mar11 + time0230);
        tzName2 = testFormat.format(date);
   //     System.out.println(format.format(date));
        pass = ((tzName1.equals("PST") && tzName2.equals("PDT")) ||
			(tzName1.equals("EST") && tzName2.equals("EDT")));
        boolean result = pass;
        String testPass = pass ? "Pass" : "FAIL";
 //       System.out.println(testPass);
    //    System.out.println("April 8 times - 0.5 hours in and 2.5 hours in [correct = both PDT]:");
        date = new Date(apr8 + time0030);
        tzName1 = testFormat.format(date);
        //System.out.println(format.format(date));
        date = new Date(apr8 + time0230);
        tzName2 = testFormat.format(date);
//        System.out.println(format.format(date));
        pass = ((tzName1.equals("PDT") && tzName2.equals("PDT")) ||
			(tzName1.equals("EDT") && tzName2.equals("EDT")));
        if (pass) {
        //    System.out.println("Pass");
        } else {
            System.out.println("FAIL");
            System.out.println("*** Something is very wrong - exiting.");
            System.exit(2);
        }
	System.out.println("*** " + testName + " Test result = " + testPass);
        return result;
    }

    public static void main(String[] args) throws Exception {
        int returnstatus = 0;
        System.err.println("Default locale: " + Locale.getDefault());
        System.err.println("Default timezone: " + TimeZone.getDefault().getDisplayName());
        // System.out.println("Jan 1 = " + new Date(jan1));
        // System.out.println("Mar 11 = " + new Date(mar11));
        // System.out.println("Apr 8 = " + new Date(apr8));

        TimeZone tz = TimeZone.getTimeZone("America/Nassau");
        Locale locale = Locale.ENGLISH;
        boolean result = true;
/* not yet ready 
	if (!doTest("Nassau", tz, locale)) {
		results=false;
		returnstatus += 2;
  	}
*/
        tz = TimeZone.getTimeZone("America/Vancouver");
        locale = Locale.CANADA;
	if (!doTest ("Canada", tz, locale)) {
		result = false;
		returnstatus += 4;
	}
	

        tz = TimeZone.getTimeZone("America/Los_Angeles");
        locale = Locale.US;
	if (!doTest ("U.S.", tz, locale)) {
		result = false;
		returnstatus += 8;
	}

        System.err.println("==========");
        if (result) {
//            System.out.println("All tests passed - do not need JVM update.");
	    System.exit(0);
        } else {
            //System.out.println("*** At least one test failed - JVM update needed.");
	System.exit(returnstatus);
        }
    }
}

